<template>
  <v-row>
    <v-col>
      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="RankListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddRankBtn" @click="createRank()">
          <v-icon left>add</v-icon>
          Ajouter un grade
        </v-btn>
      </div>

      <v-data-table :headers="headers" :items="ranksFiltered" disable-pagination hide-default-footer
        :rows-props="rowDisabledClass" density="compact" loading-text="Chargement des rangs ..."
        no-results-text="Aucun rang ne correspond à cette recherche"
        no-data-text="Aucun rang ne correspond à cette recherche" class="airvam-table">

        <template #item.actions="{ item }">
          <div class="d-flex">
            <v-btn icon size="x-small" data-cy="EditRankBtn" @click="askEditRank(item)" class="mr-1 action" flat>
              <v-icon>edit</v-icon>
            </v-btn>

            <v-btn icon size="x-small" class="action" data-cy="DeleteRankBtn" @click="askActivateDeactivateRank(item)" flat>
              <v-icon v-if="!item.disabled">delete</v-icon>
              <v-icon v-if="item.disabled">settings_backup_restore</v-icon>
            </v-btn>
          </div>
        </template>
      </v-data-table>


      <LazyAdminRanksRankDialog v-if="rankDialog && editedRank" v-model="rankDialog" :rank="editedRank"
        @confirm="createEditRank" @close="close" />

      <LazyConfirmDialog v-if="rankDialogActivateDeactivate" v-model="rankDialogActivateDeactivate"
        :dialogText="rankDialogActivateDeactivateText" :dialogTitle="rankDialogActivateDeactivateTitle"
        @confirm="activateDeactivateRank" @close="close" />
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { debounce } from "../../mixins/utilsMixin";
import { Rank } from "~/dto/rank.dto";

const store = useStore();
const { ranks } = storeToRefs(useStore());
const { $api, $toast } = useNuxtApp();

const rankDialog = ref(false);
const rankDialogActivateDeactivate = ref(false);
const rankDialogActivateDeactivateTitle = ref('');
const rankDialogActivateDeactivateText = ref('');
const editedRank: Ref<Rank | null> = ref(null);
const ranksFiltered: Ref<Rank[]> = ref([]);
const query = ref('');
const headers: Ref<any[]> = ref([
  { title: 'Ordre de classement', value: 'rank', },
  { title: 'Grade', value: 'name' },
  { title: 'Armée / Catégorie', value: 'category' },
  { title: '', value: 'actions', sortable: false },
]);

const createRank = () => {
  const rank = new Rank();
  askEditRank(rank);
}

const askEditRank = (item: Rank) => {
  editedRank.value = Object.assign({}, item);
  rankDialog.value = true;
}

const askActivateDeactivateRank = (item: Rank) => {
  editedRank.value = Object.assign({}, item);
  rankDialogActivateDeactivateTitle.value = item.disabled ? `Activation d'un grade` : `Désactivation d'un grade`
  rankDialogActivateDeactivateText.value = item.disabled ? `Êtes-vous sûr de vouloir ré-activer le grade "${editedRank.value.name}" ?` : `Êtes-vous sûr de vouloir désactiver le grade "${editedRank.value.name}" ?`;
  rankDialogActivateDeactivate.value = true;
}

const close = () => {
  rankDialogActivateDeactivate.value = false;
  rankDialog.value = false;
  editedRank.value = null;
}

const createEditRank = async () => {
  try {
    const rankReturned = editedRank.value?.id ? await $api.rank.update(formatRank(editedRank.value), editedRank.value.id.toString())
      : await $api.rank.create(formatRank(editedRank.value));
    await store.editList({ listName: 'ranks', item: rankReturned });
    $toast.success(editedRank.value?.id ? "Grade modifié" : "Grade crée");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedRank.value?.id ? "Erreur lors de l'édition d'un grade" : "Erreur lors de la création d'un grade");
  }
  filter();
  close();
}

const activateDeactivateRank = async () => {
  try {
    const rankReturned = editedRank.value?.disabled ? await $api.rank.activate(editedRank.value.id.toString())
      : await $api.rank.delete(editedRank.value!.id.toString());
    await store.editList({ listName: 'ranks', item: rankReturned });
    $toast.success(rankReturned.disabled ? "Grade désactivé" : "Grade ré-activé");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedRank.value?.disabled ? "Erreur lors de la ré-activation d'un grade" : "Erreur lors de la désactivation d'un grade");
  }
  filter();
  close();
}

const formatRank = (rank: Rank | null) => {
  const rankToReturn = Object.assign({}, rank);
  rankToReturn.rank = Number(rankToReturn.rank);
  return rankToReturn;
}

const rowDisabledClass = ({ item }: { item: Rank }) => {
  return item.disabled ? { class: "disabled" } : undefined;
}

const filter = () => {
  ranksFiltered.value = [...ranks.value].filter(r => {
    if (!query.value || query.value === '') {
      return true;
    }
    return r.name?.toUpperCase().includes(query.value.toUpperCase())
      || r.category?.toUpperCase().includes(query.value.toUpperCase())
  });
}

filter();

watch(query, debounce(function () {
  filter();
}, 300));

</script>
